<script setup lang="ts">
import type { WorkflowExecutionOut } from "@/client/types.gen.ts";
import dayjs from "dayjs";
import { useNameStore, useUserStore } from "@/stores";
import DeleteModal from "@/components/modals/DeleteModal.vue";

const props = defineProps<{
  modalId: string;
  execution?: WorkflowExecutionOut;
  backModalId?: string;
}>();

const nameRepository = useNameStore();
const userRepository = useUserStore();

const emit = defineEmits<{
  (e: "confirm-delete", executionId: string): void;
}>();

function deleteExecution() {
  if (props.execution != undefined) {
    emit("confirm-delete", props.execution.execution_id);
    window._paq?.push(["trackEvent", "Delete", "execution"]);
  }
}
</script>

<template>
  <delete-modal
    :modal-id="props.modalId"
    :back-modal-id="props.backModalId"
    delete-type="Workflow Execution"
    :disabled="props.execution == undefined"
    @confirm-delete="deleteExecution"
  >
    <template #body>
      <div class="mb-4">
        Are you sure you want to delete this workflow execution?
        <table v-if="props.execution" class="table table-hover mt-2">
          <tbody>
            <tr v-if="execution?.workflow_id && execution.workflow_version_id">
              <th scope="row" class="text-end"><b>Workflow</b></th>
              <th>
                {{ nameRepository.getName(execution.workflow_id) }}@{{
                  nameRepository.getName(execution.workflow_version_id)
                }}
              </th>
            </tr>
            <tr>
              <th scope="row" class="text-end"><b>Start time</b></th>
              <th>
                {{
                  dayjs
                    .unix(execution?.start_time ?? 0)
                    .format("MMM DD, YYYY HH:mm:ss")
                }}
              </th>
            </tr>
            <tr v-if="userRepository.currentUID !== execution?.executor_id">
              <th scope="row" class="text-end"><b>User</b></th>
              <th>
                {{ nameRepository.getName(execution?.executor_id) }}
              </th>
            </tr>
          </tbody>
        </table>
      </div>
    </template>
  </delete-modal>
</template>

<style scoped></style>
